<?php

namespace Drupal\taxonomy_entity_index\Plugin\views\argument;

use Drupal\Component\Uuid\Uuid;

/**
 * Argument handler for entity taxonomy terms with depth, using the UUID.
 *
 * @ingroup views_argument_handlers
 *
 * @ViewsArgument("taxonomy_entity_index_term_uuid_depth")
 */
final class TaxonomyEntityIndexUuidDepth extends TaxonomyEntityIndexDepth {

  /**
   * {@inheritdoc}
   */
  protected function convertIdsToEntityIds($ids) {
    if (!is_array($ids)) {
      $ids = [$ids];
    }

    $entity_ids = [];
    $entity_type = 'taxonomy_term';

    foreach ($ids as $uuid) {
      if (!Uuid::isValid($uuid) || (!$entity = $this->entityRepository->loadEntityByUuid($entity_type, $uuid))) {
        continue;
      }
      $entity_ids[] = $entity->id();
    }
    return $entity_ids;
  }

}
